#include <Foundation/Foundation.h>
#include <RegEx/RegEx.h>

int main (int argc, const char **argv)
{
  NSRange range;
  NSAutoreleasePool *pool;
  NSArray *paths;
  NSFileManager *fileManager;
  NSString *path;
  NSBundle *bundle;
  Class RegExClass;
  int i;

  pool = [NSAutoreleasePool new];
  fileManager = [NSFileManager defaultManager];

  /* Search for the bundles */
  paths = NSSearchPathForDirectoriesInDomains(NSLibraryDirectory,
                                              NSLocalDomainMask, YES);

  for (i = 0; i < [paths count]; i++)
    {
      path = [[paths objectAtIndex: i] stringByAppendingPathComponent: @"Bundles/RegEx.bundle"];
      if ([fileManager fileExistsAtPath: path])
        break;
    }

  bundle = [NSBundle bundleWithPath: path];
  RegExClass = [bundle principalClass];

  range = [RegExClass rangeOfString: @"middle"
                           inString: @"head middle end"];

  NSLog(@"%@", NSStringFromRange(range));
  
  RELEASE(pool);
  return 0;
}
